<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_2</title>
</head>
<body>
    <h1>Capitulo 2</h1>
    <a>Ejercicio 5</a>

    <script>

let head;

class Node {
    constructor(val) {
        this.data = val;
        this.next = null;
    }
}

//Función largo de la lista
function tamaño() {
   let nodoActual = null, 
             size = 1;
       nodoActual = head;

   while (nodoActual !== null && nodoActual.next !== null) {
        size++;
        nodoActual = nodoActual.next;
   }
   return size;
}

//Función Invertir lista
function invertir(node) {
    var prev = null,
     current = node,
        next = null;
    while (current != null) {
        next = current.next;
        current.next = prev;
        prev = current;
        current = next;
    }
    node = prev;
    return node;
}

//Función sumar lista
function suma(node) {
    var ptr1 = null,
        tama = tamaño();
        cont = 1;
        ptr1 = invertir(head);
    
    while (ptr1 !== null && ptr1.next !== null) {
        cont += ptr1.data;
        ptr1 = ptr1.next;
    }
    return cont
}

function imprimirList(node) {
    while (node !== null) {
        console.log( node.data + " ");
        node = node.next
    }
}

head = new Node(1);
head.next = new Node(5);
head.next.next = new Node(3);
head.next.next.next = new Node(8);

console.log("La lista de nodos es: ")
imprimirList(head);
let s = suma();
console.log("suma: " + s);

    </script>
    
</body>
</html>